{$APPTYPE GUI}
program space_invader;
uses sysutils,display;

var i,j,k,l,m,n:longword;
var c:char;

var w:longword=384;
var h:longword=384;
var sz:longword=384;

const bmpmains='image\blank.bmp';
const bmporis='image\space_invader.bmp';
var bmpmain:pbitmap;
var bmpori:pbitmap;
var bmp:array[1..8,1..16]of pbitmap;
var bmpblank:pbitmap;
var bmpship:array[1..2]of pbitmap;
var bmpshipx:array[1..2,1..2]of pbitmap;
var bmpufo1,bmpufo1x:array[1..2]of pbitmap;
var bmpufo2,bmpufo2x:array[1..3]of pbitmap;
var bmpwallr:array[0..4,0..4]of pbitmap;
var bmpwallt1,bmpwallt2:array[0..2,0..2]of pbitmap;
var bmpwallt:array[0..0,0..0]of pbitmap;
var bmpbullet:array[1..3,1..4]of pbitmap;
var bmpinvader:array[1..5,1..2]of pbitmap;
var bmpinvaderx:pbitmap;
var bmpchar:array[ord(' ')..ord('_')]of pbitmap;

const wavinvaders:array[1..4]of string=('audio\1.wav','audio\2.wav','audio\3.wav','audio\4.wav');
const wavfires='audio\fire.wav';
const wavhits='audio\hit.wav';
const wavloses='audio\lose.wav';
const wavufos='audio\ufo.wav';
const wavufohits='audio\ufohit.wav';
const wavlifeups='audio\lifeup.wav';
var wavinvader:array[1..4]of longword;
var wavfire,wavhit,wavlose,wavufo,wavufohit,wavlifeup:longword;

const c1=$3333FF;
const c2=$3399FF;
const c3=$33FFFF;
const c4=$33FF33;
const c5=$FFFF00;
const c6=$FF6633;
const c7=$FF33FF;
const c8=$BB33BB;
const c9=$773377;
const c0=$333333;

const framespeed:real=0.1;
const invaderc:array[1..5]of longword=(c1,c3,c4,c6,c7);
const wallc:longword=c2;
const wallhp:array[1..3,1..3]of longword=((3,5,5),(5,5,1),(3,5,5));
const bullethp:array[1..3]of longword=(2,4,4);
const lifeupnum=3000;
const invaderframe:longword=32;
const shipframe:longword=128;
const ufoframe:longword=64;
const waitframe:longword=128;

type tobj=record x,y,b:longint;end;

var invader:array[1..11,1..5]of tobj;
var invaderd,invaders:longint;
var invaderleft,invaderright:tobj;
var invadernum:longword;
var ship:tobj;
var shipd:longint;
var shipl,shipr,shipf:boolean;
var ufo1,ufo2:tobj;
var bulletship:tobj;
var bullet:array[1..3]of tobj;
var wall:array[1..3,1..3,1..4]of tobj;

var starttime:longword;
var framenum:longword;
var stepnum:longword;
var movenum:longword;
var downnum:longword;
var startnum:longword;
var endnum:longword;

var level:longint;
var score:longint;
var gameover:boolean;
var life:longint;
var choose:longint=1;
var playername:string;
var shifton:boolean;

type tscore=record level:longint;name:string;score:longint;end;
var scorea:array[1..10]of tscore;
const scorec:array[1..10]of longword=(c1,c2,c3,c4,c5,c6,c7,c8,c9,c0);
var scorenum:longword=0;
var scoref:text;
var drawblank:boolean=false;

procedure initaudio();
begin
for i:=1 to 4 do
  wavinvader[i]:=LoadAudio(wavinvaders[i]);
wavfire:=LoadAudio(wavfires);
wavhit:=LoadAudio(wavhits);
wavlose:=LoadAudio(wavloses);
wavufo:=LoadAudio(wavufos);
wavufohit:=LoadAudio(wavufohits);
wavlifeup:=LoadAudio(wavlifeups);
end;

procedure initimage();
begin
bmpmain:=loadbmp(bmpmains,transparent);
bmpori:=loadbmp(bmporis,black);
for j:=1 to 8 do
  for i:=1 to 16 do
    bmp[j,i]:=copybmp(bmpori,(i-1)*8,(j-1)*8,0,0,8,8);
bmpship[1]:=bmp[1,1];
bmpship[2]:=bmp[1,2];
bmpshipx[1,1]:=bmp[1,3];
bmpshipx[2,1]:=bmp[1,4];
bmpshipx[1,2]:=bmp[1,5];
bmpshipx[2,2]:=bmp[1,6];
bmpufo1[1]:=bmp[1,7];
bmpufo1[2]:=bmp[1,8];
bmpufo1x[1]:=bmp[1,9];
bmpufo1x[2]:=bmp[1,10];
bmpufo2[1]:=bmp[1,11];
bmpufo2[2]:=bmp[1,12];
bmpufo2[3]:=bmp[1,13];
bmpufo2x[1]:=bmp[1,14];
bmpufo2x[2]:=bmp[1,15];
bmpufo2x[3]:=bmp[1,16];
bmpwallr[0,0]:=bmp[2,1];
bmpwallr[1,0]:=bmp[2,2];
bmpwallr[2,0]:=bmp[2,3];
bmpwallr[3,0]:=bmp[2,4];
bmpwallr[4,0]:=bmp[2,5];
bmpwallr[0,1]:=bmp[2,6];
bmpwallr[1,1]:=bmp[2,7];
bmpwallr[2,1]:=bmp[2,8];
bmpwallr[3,1]:=bmp[2,9];
bmpwallr[0,2]:=bmp[2,10];
bmpwallr[1,2]:=bmp[2,11];
bmpwallr[2,2]:=bmp[2,12];
bmpwallr[0,3]:=bmp[2,13];
bmpwallr[1,3]:=bmp[2,14];
bmpwallr[0,4]:=bmp[2,15];
bmpwallt[0,0]:=bmp[2,16];
bmpwallt1[0,0]:=bmp[3,1];
bmpwallt1[1,0]:=bmp[3,2];
bmpwallt1[2,0]:=bmp[3,3];
bmpwallt1[0,1]:=bmp[3,4];
bmpwallt1[1,1]:=bmp[3,5];
bmpwallt1[0,2]:=bmp[3,6];
bmpwallt2[0,0]:=bmp[3,7];
bmpwallt2[1,0]:=bmp[3,8];
bmpwallt2[2,0]:=bmp[3,9];
bmpwallt2[0,1]:=bmp[3,10];
bmpwallt2[1,1]:=bmp[3,11];
bmpwallt2[0,2]:=bmp[3,12];
bmpbullet[1,1]:=bmp[4,1];
bmpbullet[1,2]:=bmp[4,2];
bmpbullet[2,1]:=bmp[4,3];
bmpbullet[2,2]:=bmp[4,4];
bmpbullet[2,3]:=bmp[4,5];
bmpbullet[2,4]:=bmp[4,6];
bmpbullet[3,1]:=bmp[4,7];
bmpbullet[3,2]:=bmp[4,8];
bmpbullet[3,3]:=bmp[4,9];
bmpbullet[3,4]:=bmp[4,10];
bmpinvader[1,1]:=bmp[3,13];
bmpinvader[1,2]:=bmp[4,13];
bmpinvader[2,1]:=bmp[3,14];
bmpinvader[2,2]:=bmp[4,14];
bmpinvader[3,1]:=bmp[3,15];
bmpinvader[3,2]:=bmp[4,15];
bmpinvader[4,1]:=bmp[3,16];
bmpinvader[4,2]:=bmp[4,16];
bmpinvader[5,1]:=bmp[4,12];
bmpinvader[5,2]:=bmp[4,12];
bmpinvaderx:=bmp[4,11];
for j:=1 to 4 do
  for i:=1 to 16 do
    bmpchar[ord(' ')+(i-1)+(j-1)*16]:=bmp[4+j,i];
bmpblank:=copybmp(bmpchar[ord(' ')]);
end;

procedure savehighscore();
begin
rewrite(scoref);
writeln(scoref,scorenum);
for i:=1 to scorenum do
  begin
  writeln(scoref,scorea[i].level);
  writeln(scoref,scorea[i].name);
  writeln(scoref,scorea[i].score);
  end;
close(scoref);
end;

procedure loadhighscore();
begin
assign(scoref,'space_invader_score.dat');
if fileexists('space_invader_score.dat') then
  begin
  reset(scoref);
  readln(scoref,scorenum);
  for i:=1 to scorenum do
    begin
    readln(scoref,scorea[i].level);
    readln(scoref,scorea[i].name);
    readln(scoref,scorea[i].score);
    end;
  close(scoref);
  end;
savehighscore();
end;

procedure playwav(wav:longword);
begin
SetAudioPos(wav,0);
end;

procedure drawbmpc(b:pbitmap;x,y:longint;c:longword);
begin
bar(bmpblank,0,0,8,8,c);
drawbmp(b,bmpblank,white);
drawbmp(bmpblank,bmpmain,x,y,black);
end;

procedure drawstring(s:string;x,y:longint;c:longword);
begin
for i:=1 to length(s) do
  begin
  if drawblank then
    bar(bmpmain,x+(i-1)*8,y,8,8,black);
  drawbmpc(bmpchar[ord(s[i])],x+(i-1)*8,y,c);
  end;
end;

procedure drawstrleft(s:string;h:longint;c:longword);
begin
drawstring(s,0,h*8,c);
end;

procedure drawstrmid(s:string;h:longint;c:longword);
begin
drawstring(s,96-length(s)*4,h*8,c);
end;

procedure drawstrright(s:string;h:longint;c:longword);
begin
drawstring(s,192-length(s)*8,h*8,c);
end;

procedure drawwin();
begin
bar(0,0,_w,_h,black);
sz:=min(_w,_h);
drawbmp(bmpmain,_pmain,0,0,192,192,(_w-sz)div 2,(_h-sz)div 2,sz,sz,transparent);
freshwin();
delay(1);
bar(bmpmain,0,0,192,192,black);
end;

procedure drawmenu();
begin
drawstrmid('SPACE INVADER',2,white);
drawstrmid('  = 50 POINTS',6,c1);
drawstrmid('  = 40 POINTS',8,c3);
drawstrmid('  = 30 POINTS',10,c4);
drawstrmid('  = 20 POINTS',12,c6);
drawstrmid('  = 10 POINTS',14,c7);
if choose=1 then
  begin
  drawstrmid('* PLAY GAME  ',17,c5);
  drawstrmid('  HIGH SCORE  ',19,white);
  end
else
  begin
  drawstrmid('  PLAY GAME  ',17,white);
  drawstrmid('* HIGH SCORE  ',19,c5);
  end;
drawstrmid('MADE BY AX_POKL',22,c2);
for j:=1 to 5 do
  drawbmpc(bmpinvader[6-j,2],6*8,(j*2+4)*8,invaderc[j]);
drawwin();
end;

procedure drawhighscore();
begin
drawstrmid('HIGH SCORE',2,white);
for l:=1 to scorenum do
  begin
  drawstrmid(i2s(l)+'                     ',(l+1)*2,scorec[l]);
  drawstrleft('   '+i2s(scorea[l].level),(l+1)*2,scorec[l]);
  drawstrmid(scorea[l].name+'  ',(l+1)*2,scorec[l]);
  drawstrright(i2s(scorea[l].score)+' ',(l+1)*2,scorec[l]);
  end;
drawwin();
end;

procedure drawgethighscore();
begin
bar(bmpmain,0,23*8,w,8,black);
drawbmpc(bmpshipx[1,framenum mod 2+1],ship.x,ship.y,white);
drawbmpc(bmpshipx[2,framenum mod 2+1],ship.x+8,ship.y,white);
drawblank:=true;
drawstrmid('YOUR NAME',10,c2);
drawstrmid(playername,12,c5);
drawblank:=false;
drawwin();
end;

procedure drawplay();
begin
for j:=1 to 5 do
  for i:=1 to 11 do
    begin
    if invader[i,j].b=1 then
      drawbmpc(bmpinvader[6-j,invaders],invader[i,j].x,invader[i,j].y,invaderc[j]);
    if invader[i,j].b<0 then
      drawbmpc(bmpinvaderx,invader[i,j].x,invader[i,j].y,invaderc[j]);
    end;
if ship.b=1 then
  begin
  drawbmpc(bmpship[1],ship.x,ship.y,white);
  drawbmpc(bmpship[2],ship.x+8,ship.y,white);
  end;
if ship.b<0 then
  begin
  drawbmpc(bmpshipx[1,-ship.b mod 2+1],ship.x,ship.y,white);
  drawbmpc(bmpshipx[2,-ship.b mod 2+1],ship.x+8,ship.y,white);
  end;
if ufo2.b>=1 then
  begin
  drawbmpc(bmpufo2[1],ufo2.x,ufo2.y,white);
  drawbmpc(bmpufo2[2],ufo2.x+8,ufo2.y,white);
  drawbmpc(bmpufo2[3],ufo2.x+16,ufo2.y,white);
  end;
if ufo2.b<0 then
  begin
  drawbmpc(bmpufo2x[1],ufo2.x,ufo2.y,white);
  drawbmpc(bmpufo2x[2],ufo2.x+8,ufo2.y,white);
  drawbmpc(bmpufo2x[3],ufo2.x+16,ufo2.y,white);
  end;
if ufo1.b>=1 then
  begin
  drawbmpc(bmpufo1[1],ufo1.x,ufo1.y,white);
  drawbmpc(bmpufo1[2],ufo1.x+8,ufo1.y,white);
  end;
if ufo1.b<0 then
  begin
  drawbmpc(bmpufo1x[1],ufo1.x,ufo1.y,white);
  drawbmpc(bmpufo1x[2],ufo1.x+8,ufo1.y,white);
  end;
for k:=1 to 4 do
  for j:=1 to 3 do
    for i:=1 to 3 do
      begin
      if wall[i,j,k].b>0 then
        begin
        m:=9-wall[i,j,k].b div 10;
        n:=9-wall[i,j,k].b mod 10;
        if (i=1) and (j=1) then
          drawbmpc(bmpwallt1[m,n],wall[i,j,k].x,wall[i,j,k].y,wallc)
        else if (i=3) and (j=1) then
          drawbmpc(bmpwallt2[m,n],wall[i,j,k].x,wall[i,j,k].y,wallc)
        else if (i=2) and (j=3) then
          drawbmpc(bmpwallt[m,n],wall[i,j,k].x,wall[i,j,k].y,wallc)
        else
          drawbmpc(bmpwallr[m,n],wall[i,j,k].x,wall[i,j,k].y,wallc);
        end;
      end;
if bulletship.b>0 then
  line(bmpmain,bulletship.x+4,bulletship.y,0,7,white);
for l:=1 to 3 do
  if bullet[l].b>0 then
    drawbmpc(bmpbullet[l,bullet[l].b div 100 mod bullethp[l]+1],bullet[l].x,bullet[l].y,white);
drawstrleft(i2s(level),0,white);
drawstrmid(i2s(score),0,white);
if life>5 then
  begin
  drawbmpc(bmpship[1],192-16,0,white);
  drawbmpc(bmpship[2],192-16+8,0,white);
  drawstring(i2s(life-1),192-16-length(i2s(life-1))*8,0,white);
  end
else
  for i:=2 to life do
    begin
    drawbmpc(bmpship[1],192-(i-1)*16,0,white);
    drawbmpc(bmpship[2],192-(i-1)*16+8,0,white);
    end;
if startnum<waitframe then
  begin
  drawstrmid('WAVE '+i2s(level),14,white);
  drawstrmid('READY!',16,white);
  end;
if invadernum=0 then
  drawstrmid('NEXT WAVE',12,white);
if not(gameover) then
  drawwin();
end;

procedure getinvaderleftright();
begin
for i:=11 downto 1 do
  for j:=1 to 5 do
    if invader[i,j].b=1 then
      invaderleft:=invader[i,j];
for i:=1 to 11 do
  for j:=1 to 5 do
    if invader[i,j].b=1 then
      invaderright:=invader[i,j];
end;

procedure getinvadernum();
begin
invadernum:=0;
for i:=1 to 11 do
  for j:=1 to 5 do
    if invader[i,j].b=1 then
      invadernum:=invadernum+1;
end;

procedure addscore(n:longword);
begin
if score mod lifeupnum>(score+n) mod lifeupnum then
  begin
  life:=life+1;
  playwav(wavlifeup);
  end;
score:=score+n;
end;

procedure clearwall(i,j,k:longword);
begin
m:=9-wall[i,j,k].b div 10;
n:=9-wall[i,j,k].b mod 10;
if m+n>=wallhp[i,j] then wall[i,j,k].b:=0;
end;

procedure nextstep();
begin
playwav(wavinvader[movenum mod 4+1]);
movenum:=movenum+1;
stepnum:=0;
getinvaderleftright();
if (invaderleft.x<=0) or (invaderright.x>=(24-1)*8) then
  begin
  invaderd:=-invaderd;
  for j:=1 to 5 do
    for i:=1 to 11 do
      invader[i,j].y:=invader[i,j].y+8;
  downnum:=downnum+1;
  for j:=1 to 5 do
    for i:=1 to 11 do
      if (invader[i,j].b>0) then k:=(j-1)*2;
  if k+downnum>=20 then gameover:=true;
  end;
for j:=1 to 5 do
  for i:=1 to 11 do
    if invader[i,j].b>0 then
      invader[i,j].x:=invader[i,j].x+invaderd;
invaders:=3-invaders;
end;

procedure nextframe();
begin
framenum:=framenum+1;
stepnum:=stepnum+1;
ship.x:=ship.x+shipd;
if ship.x<0 then ship.x:=0;
if ship.x>175 then ship.x:=175;
if bulletship.b>0 then bulletship.y:=bulletship.y-2;
if bulletship.y<8 then bulletship.b:=0;
for l:=1 to 3 do
  if (bulletship.b>0) and (bullet[l].b>0) then
    if (abs(bulletship.x-bullet[l].x)<2)
    and (bulletship.y<bullet[l].y+8) then
      begin
      bulletship.b:=0;
      bullet[l].b:=0;
      end;
for k:=1 to 4 do
  for j:=3 downto 1 do
    for i:=1 to 3 do
      if (bulletship.b>0) and (wall[i,j,k].b>0) then
        if (bulletship.x+4>=wall[i,j,k].x)
        and (bulletship.x+4<wall[i,j,k].x+8)
        and (bulletship.y<wall[i,j,k].y+8) then
          begin
          bulletship.b:=0;
          wall[i,j,k].b:=wall[i,j,k].b-1;
          clearwall(i,j,k);
          end;
for j:=5 downto 1 do
  for i:=1 to 11 do
    if (bulletship.b>0) and (invader[i,j].b>0) then
      if (bulletship.x+4>=invader[i,j].x)
      and (bulletship.x+4<invader[i,j].x+8-(5-j))
      and (bulletship.y<invader[i,j].y+8)
      and (bulletship.y>invader[i,j].y-8) then
        begin
        bulletship.b:=0;
        invader[i,j].b:=-invaderframe;
        playwav(wavhit);
        addscore((6-j)*10);
        getinvadernum();
        end;
for l:=1 to 3 do
  begin
  if bullet[l].b>0 then
    begin
    bullet[l].b:=bullet[l].b+100;
    bullet[l].y:=bullet[l].y+1;
    end;
  if 192-bullet[l].y<8 then
    bullet[l].b:=0;
  for k:=1 to 4 do
    for j:=3 downto 1 do
      for i:=1 to 3 do
        if (bullet[l].b>0) and (wall[i,j,k].b>0) then
          if (bullet[l].x+4+1>=wall[i,j,k].x)
          and (wall[i,j,k].x+8>(bullet[l].x+4-1))
          and (bullet[l].y+8>wall[i,j,k].y) then
            begin
            bullet[l].b:=0;
            wall[i,j,k].b:=wall[i,j,k].b-10;
            clearwall(i,j,k);
            end;
  if (bullet[l].b>0) and (ship.b>0) then
    if (bullet[l].x+4+1>=ship.x+3)
    and (ship.x+14>(bullet[l].x+4-1))
    and (bullet[l].y+8>ship.y) then
      begin
      ship.b:=-shipframe;
      playwav(wavlose);
      end;
  if bullet[l].b=0 then
    begin
    repeat
    i:=random(11)+1;
    j:=5;
    while (invader[i,j].b<=0) and (j>1) do j:=j-1;
    until (invader[i,j].b>0) or (invadernum=0);
    bullet[l].x:=invader[i,j].x;
    bullet[l].y:=invader[i,j].y+8;
    if ((bullet[1].b mod 100<>(i+j*10)) or (bullet[1].b div 100>8))
    and ((bullet[2].b mod 100<>(i+j*10)) or (bullet[2].b div 100>8))
    and ((bullet[3].b mod 100<>(i+j*10)) or (bullet[3].b div 100>8))
    and (random(1000)<level) then
      bullet[l].b:=100+i+j*10;
    end;
  end;
for n:=5 downto 1 do
  for m:=1 to 11 do
    for k:=1 to 4 do
      for j:=1 to 3 do
        for i:=1 to 3 do
          if (invader[m,n].b>0) and (wall[i,j,k].b>0) then
            if (invader[m,n].x>wall[i,j,k].x-8) and (invader[m,n].x<wall[i,j,k].x+8)
            and (invader[m,n].y>wall[i,j,k].y-8) and (invader[m,n].y<wall[i,j,k].y+8)
            then wall[i,j,k].b:=0;
for j:=1 to 5 do
  for i:=1 to 11 do
    if invader[i,j].b<0 then
      invader[i,j].b:=invader[i,j].b+1;
if ((ufo1.b>=1) or (ufo2.b>=1))
 and (getaudiopos(wavufo)=getaudiolen(wavufo)) then
  playwav(wavufo);
if (ufo1.b=0) and (ufo2.b=0) and (random((abs(invadernum-27)+10)*200)=0) then
  begin
  playaudio(wavufo);
  if random(10)=0 then
    begin
    ufo1.b:=random(2)*2+1;
    if ufo1.b=1 then ufo1.x:=192-16 else ufo1.x:=0;
    ufo1.y:=8;
    end
  else
    begin
    ufo2.b:=random(2)*2+1;
    if ufo2.b=1 then ufo2.x:=192-24 else ufo2.x:=0;
    ufo2.y:=8;
    end
  end
else if ufo1.b>=1 then
  ufo1.x:=ufo1.x+ufo1.b-2
else if ufo2.b>=1 then
  ufo2.x:=ufo2.x+ufo2.b-2
else if ufo1.b<0 then
  ufo1.b:=ufo1.b+1
else if ufo2.b<0 then
  ufo2.b:=ufo2.b+1;
if ufo1.x<0 then ufo1.b:=0;
if ufo2.x<0 then ufo2.b:=0;
if ufo1.x+16>192 then ufo1.b:=0;
if ufo2.x+24>192 then ufo2.b:=0;
if (ufo1.b>0) and (bulletship.b>0) then
  if (bulletship.x+4>=ufo1.x+1) and (bulletship.x+4<ufo1.x+16-1)
  and (bulletship.y<ufo1.y+8) then
    begin
    bulletship.b:=0;
    ufo1.b:=-ufoframe;
    stopaudio(wavufo);
    playwav(wavufohit);
    playwav(wavlifeup);
    life:=life+1;
    end;
if (ufo2.b>0) and (bulletship.b>0) then
  if (bulletship.x+4>=ufo2.x+2) and (bulletship.x+4<ufo2.x+24-2)
  and (bulletship.y<ufo2.y+8) then
    begin
    bulletship.b:=0;
    ufo2.b:=-ufoframe;
    stopaudio(wavufo);
    playwav(wavufohit);
    addscore(200);
    end;
end;

procedure nextframehit();
begin
framenum:=framenum+1;
ship.b:=ship.b+1;
if ship.b=0 then
  begin
  ship.b:=1;
  for l:=1 to 3 do
    bullet[l].b:=0;
  life:=life-1;
  if life=0 then gameover:=true;
  end;
end;

procedure nextframewait();
begin
if startnum<waitframe then
  startnum:=startnum+1;
if invadernum=0 then
  endnum:=endnum+1;
framenum:=framenum+1;
if (startnum=waitframe) and (endnum=0) then
  begin
  ship.b:=1;
  nextstep();
  end;
end;

procedure getact();
begin
if ismsg(256) then
  begin
  if _ms.wParam=K_LEFT then shipl:=true;
  if _ms.wParam=K_RIGHT then shipr:=true;
  if _ms.wParam=K_SPACE then shipf:=true;
  end;
if ismsg(257) then
  begin
  if _ms.wParam=K_LEFT then shipl:=false;
  if _ms.wParam=K_RIGHT then shipr:=false;
  if _ms.wParam=K_SPACE then shipf:=false;
  end;
shipd:=0;
if shipl then shipd:=shipd-1;
if shipr then shipd:=shipd+1;
if shipf then
  if bulletship.b=0 then
    begin
    bulletship.x:=ship.x+4;
    bulletship.y:=ship.y-8;
    bulletship.b:=1;
    playwav(wavfire);
    end;
if iskey(K_ESCAPE) then gameover:=true;
end;

procedure initlevel();
begin
level:=level+1;
for j:=1 to 5 do
  for i:=1 to 11 do
    begin
    invader[i,j].x:=(i-1)*2*8+2;
    invader[i,j].y:=((j-1)*2+3)*8;
    invader[i,j].b:=1;
    end;
invaderd:=2;
invaders:=1;
getinvaderleftright();
getinvadernum;
ship.x:=(1-1)*8;
ship.y:=(24-1)*8;
ship.b:=0;
shipd:=0;
shipl:=false;
shipr:=false;
shipf:=false;
ufo1.b:=0;
ufo2.b:=0;
bulletship.b:=0;
for l:=1 to 3 do
  bullet[l].b:=0;
for k:=1 to 4 do
  for j:=1 to 3 do
    for i:=1 to 3 do
      begin
      wall[i,j,k].x:=(i+3+(k-1)*5-1)*8;
      wall[i,j,k].y:=(j+19-1)*8;
      wall[i,j,k].b:=99;
      end;
starttime:=gettime();
framenum:=0;
stepnum:=0;
movenum:=0;
downnum:=0;
startnum:=0;
endnum:=0;
end;

procedure initplay();
begin
gameover:=false;
level:=0;
score:=0;
life:=3;
end;

procedure gethighscore();
begin
playername:='';
repeat
while ((gettime()-starttime)*framespeed<framenum) do
  begin
nextmsg();
if _ms.wParam=16 then
  begin
  if ismsg(256) then shifton:=true;
  if ismsg(257) then shifton:=false;
  end;
if iskey() then
  begin
  c:=chr(getkey());
  if ord(c)=K_BACK then
    begin
    playwav(wavhit);
    delete(playername,length(playername),1);
    end;
  if not (((c>='0') and (c<='9')) or ((c>='A') and (c<='Z'))) then
  case ord(c) of
    189:c:='-';
    187:c:='=';
    219:c:='[';
    221:c:=']';
    220:c:='\';
    186:c:=';';
    222:c:='''';
    188:c:=',';
    190:c:='.';
    191:c:='/';
    else c:=#0;
    end;
  if shifton then
    begin
    if c='-' then c:='_';
    if c='=' then c:='+';
    if c='[' then c:='{';
    if c=']' then c:='}';
    if c='\' then c:='|';
    if c=';' then c:=':';
    if c='''' then c:='"';
    if c=',' then c:='<';
    if c='.' then c:='>';
    if c='/' then c:='?';
    if c='1' then c:='!';
    if c='2' then c:='@';
    if c='3' then c:='#';
    if c='4' then c:='$';
    if c='5' then c:='%';
    if c='6' then c:='^';
    if c='7' then c:='&';
    if c='8' then c:='*';
    if c='9' then c:='(';
    if c='0' then c:=')';
    end;
  if (c>=' ') and (c<='_') then
    if (length(playername)<12) then
      begin
      playername:=playername+c;
      playwav(wavfire);
      end
    else
      playwav(wavhit);
  end;
  drawplay();
  drawgethighscore();
  end;
framenum:=framenum+1;
until iskey(K_RETURN) or iskey(K_ESCAPE);
playwav(wavufohit);
k:=0;
for i:=1 to scorenum do if scorea[i].score>score then k:=i;
scorenum:=scorenum+1;
if scorenum=11 then scorenum:=10;
for i:=scorenum downto k+1 do
  if i=k+1 then
    begin
    scorea[i].score:=score;
    scorea[i].name:=playername;
    scorea[i].level:=level;
    end
  else
    scorea[i]:=scorea[i-1];
end;

procedure highscore();
begin
savehighscore();
settitle('High Score');
repeat
drawhighscore();
nextmsg();
until iskey(K_SPACE) or iskey(K_RETURN) or iskey(K_ESCAPE);
playwav(wavhit);
end;

procedure play();
begin
initplay();
repeat
initlevel();
repeat
if startnum<waitframe then
  nextframewait()
else if invadernum=0 then
  nextframewait()
else if (ship.b<0)then
  nextframehit()
else
  nextframe();
if stepnum>(sqrt(invadernum)
   +((invaderright.x-invaderleft.x)/16*5
   +(20-downnum))/sqrt(level)) then
  nextstep();
while ((gettime()-starttime)*framespeed<framenum) do
  begin
  nextmsg();
  if (startnum=waitframe) and (invadernum>0) then getact();
  drawplay();
  end;
until ((invadernum=0) and (endnum>=waitframe))or (gameover);
until gameover;
if life>0 then playwav(wavlose);
gethighscore();
highscore();
end;

procedure menu();
begin
repeat
settitle('Space Invader');
drawmenu();
nextmsg();
if iskey(K_DOWN) and (choose=1) then begin choose:=2;playwav(wavfire);end;
if iskey(K_UP) and (choose=2) then begin choose:=1;playwav(wavfire);end;
if iskey(K_SPACE) or iskey(K_RETURN) then
  begin
  if choose=1 then begin playwav(wavufohit);play();end;
  if choose=2 then begin playwav(wavhit);highscore();end;
  nextmsg();
  end;
until iskey(K_ESCAPE);
end;

procedure init();
begin
randomize();
initimage();
initaudio();
loadhighscore();
createwin(w,h);
end;

begin
init();
menu();
end.
